;------------------------------------------------------------------------------------------------------------------------------------------------------------
;La conversion de l'entre analogique AN0 est dclenche automatiquement par le TIMER3 
;Lorsque la conversion est termine le convertisseur dclenche une demande d'interruption
;la routine d'interruption  calcule et envoie les 8bits de poids forts du rsultat   sur le port D
;Le programme principal aprs l'appel des sous programmes d'initialisation excute une boucle infinie
;------------------------------------------------------------------------------------------------------------------------------------------------------------
; Ajouter  crt0.s  au projet. 
; Ce programme initialise la pile et  les variables en RAM   et  se termine par un  goto _main 
;------------------------------------------------------------------------------------------------------------------------------------------------------------
		.equ	ECH , 5		; nombre d'chantillons  traiter  (ECH est quivalent  5 ici ) 
		.global	_main               	; adresse de dbut du prog. principal 
		.global	__ADCInterrupt  	; adresse du vecteur d'interruption ADC 
;..........................................................................................................................................................................................................................................
; Rservation de 2*ECH  octets en mmoire X .   Buffer_X  est l'adresse du premier lment
;..........................................................................................................................................................................................................................................
	         	.section .xbss, "b"		; indique au  linker d'utiliser la mmoire RAM   X
buffer_X : 	.space 2*ECH        

;.........................................................................................................................................................................................................................................
;Stockage des coefficients dans la mmoire Y    
;.......................................................................................................................................................................................................................................
         		 .section .ydata, "d"		; indique au  linker d'utiliser la mmoire RAM   Y  avec des donnes  initialiser
coeff:   		 .word 0xEE49, 0x1DF8, 0x5CE1, 0x1DF8, 0xEE49

;**********************************************
;   Le Programme principal
;**********************************************
		.section        .text		; indique au  linker d'utiliser la mmoire programme
_main:		rcall   _init_dsp		;  appel des sous-programmes d'initialisation   
		rcall   _init_timer3    	              
		rcall   _init_portD
		rcall   _init_adc
		rcall  _init_int
boucle: 		nop			; boucle infinie....
		bra boucle
;fin du_programme principal..........


;*********************************************
; Routine de traitement de l'interruption ADC
;*********************************************
__ADCInterrupt: :	
		;PARTIE  COMPLETER 
			;stocker l'entre analogique dans le buffer_X
			;calculer la sortie  du filtre 
			;envoyer les poids forts de la  valeur calcule sur le PORTD muni du rseau R/2R
 
		bclr IFS0,#11		;rinitialise l'indicateur d'interruption ADC	
		RETFIE
;*******************************************
;    Les sous-programmes
;*******************************************  

_init_dsp:
		mov #????  ,W0		;  Choisir W10  et W8 pour  pointer sur les 
		mov W0,MODCON		;  buffers circulaires

		mov #coeff,W0		
		mov W0,YMODSRT		; adrersse de dbut du buffer Y
		ADD #(ECH*2)-1,W0	; calcul de l'adresse de fin
		mov W0,YMODEND
		
		mov #buffer_X,W0				
		mov W0,XMODSRT		;adrersse de dbut du buffer X
		ADD #(ECH*2)-1,W0	; calcul de l'adresse de fin
		mov W0,XMODEND
		
		mov #????, W0
		mov W0,CORCON		; Autoriser la saturation et le mode virgule fixe

		mov #coeff,W10		; Initialisation des pointeurs W10 et W8 
		mov #buffer_X,W8
		return
_init_portD:
		clr TRISD			; portD en sortie 
		return
_init_timer3:
		mov #0x8000,W0
		mov W0,T3CON
		mov #????,W0
		mov W0,PR3		; Choisir la priode du timer tel que  fe = 11025 Hz
		return
_init_adc:
		clr ADPCFG		
		mov #0x0400,W0
		mov W0,ADCON2
		mov #0x010A,W0
		mov W0,ADCON3
		mov #0x0000,W0
		mov W0,ADCHS
		mov #0x0001,W0
		mov W0,ADCSSL
		mov #0x8246,W0
		mov W0,ADCON1
		return
_init_int:
		bclr IFS0,#11				
		bset IEC0,#11		; Autorisation des interruptions ADC
		return
.end 					; fin du fichier




